//---------------------------------------------------------------------------
//
//   SelectAsymmetric
//
//          Copyright(C) 1999-2012, tetraface Inc.
//
//     Sample of Select plug-in for measuring a length of a selected line.
//     Created DLL must be installed in "Plugins\Select" directory.
//
//    @IC̒𑪂IvOC̃TvB
//    @쐬DLL"Plugins\Select"tH_ɓKvB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"
#if MQPLUGIN_VERSION >= 0x0400
#include "MQWidget.h"
#endif
#include "CMQObject.h"
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <array>
#include <memory>

using namespace std;

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A1862;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "SelectAsymmetric ver.1.2 Copyright(C) 2013, Tark.";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// I𕔕ό`pvOCł
	return MQPLUGIN_TYPE_SELECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "SelectAsymmetric:Vertex";
	case 1: return "SelectAsymmetric:Face";
	case 2: return "SelectAsymmetric:Face(with UV)";
	}
	return NULL;
}

// CNX
class SelectAsymmetric
{
	public:
		SelectAsymmetric(MQDocument doc, int mode) :
			doc_(doc),
			obj_(doc->GetObject(doc->GetCurrentObjectIndex())),
			mode_(mode) {}

		BOOL main();

	private:
		CMQDocument doc_;
		CMQObject obj_; // JgIuWFNg
		int mode_;

		static const float delta; // Wꔻp
		static const float uvdelta; // UVlꔻp

		pair<unordered_map<int, int>, unordered_set<int>> selectAsymmetricVertex();
		pair<unordered_map<int, int>, unordered_set<int>> selectAsymmetricFace(const unordered_map<int, int> &vsymmetric);
		int findFace(const vector<int> &vertexes);

		static vector<int> getSymmetricVertexesofFace(const vector<int> &vertexes, const unordered_map<int, int> &vsymmetric);

		//template <class T> static bool isReverseVector(const vector<T> &vector1, const vector<T> &vector2);
		static bool isReverseVector(const vector<int> &vector1, const vector<int> &vector2);
		static bool isReverseVector2(const vector<CMQCoordinate> &vector1, const vector<CMQCoordinate> &vector2, const unordered_map<int, int> &vsymmetric);
};

const float SelectAsymmetric::delta = 0.001f;

//---------------------------------------------------------------------------
//  MQModifySelect
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifySelect(int index, MQDocument doc)
{
	switch(index){
	case 0:
	case 1:
	case 2:
		{
			SelectAsymmetric s(doc, index);
			return s.main();
		}
	}
	return FALSE;
}


#if MQPLUGIN_VERSION >= 0x0399
#define MESSAGEBOX_(message, title) MQDialog::MessageInformationBox(MQWindow::GetMainWindow(), message, title);
#else
#define MESSAGEBOX_(message, title) MessageBox(MQ_GetWindowHandle(), message, title, MB_OK);
#endif

BOOL SelectAsymmetric::main()
{
	auto vsymmetric = selectAsymmetricVertex();
	if(mode_ == 0) {
		if(vsymmetric.second.empty()) {
			MESSAGEBOX_(L"Vertexes are symmetry.", L"SelectAsymmetric");
		}
		else {
			MESSAGEBOX_(L"Found asymmetric vertexes.", L"SelectAsymmetric");
		}
		doc_.clearSelect(MQDOC_CLEARSELECT_FACE | MQDOC_CLEARSELECT_LINE);
	}
	else if(mode_ == 1 || mode_ == 2) {
		// TODO:NɖʂłȂ_IĂꍇvsymmetrics\
		auto fasymmetric = selectAsymmetricFace(vsymmetric.first);
		if(fasymmetric.second.empty()) {
			MESSAGEBOX_(L"Faces are symmetry.", L"SelectAsymmetric");
		}
		else {
			MESSAGEBOX_(L"Found asymmetric faces.", L"SelectAsymmetric");
		}
		doc_.clearSelect(MQDOC_CLEARSELECT_VERTEX | MQDOC_CLEARSELECT_LINE);
	}
	return TRUE;
}

pair<unordered_map<int, int>, unordered_set<int>> SelectAsymmetric::selectAsymmetricVertex()
{
	int vcount = obj_.getVertexCount();
	bool is_selected = false; // NɑI𒸓_邩
	for(int i = 0; i < vcount; i++) {
		if(obj_.getVertexRefCount(i) == 0) {
			continue;
		}
		is_selected |= doc_.isSelectVertex(obj_, i);
	}

	unordered_map<int, int> symmetric; // Ώ̒_yAi[
	unordered_set<int> asymmetric; // Ώ̒_݂Ȃ̂i[
	for(int i = 0; i < vcount; i++) {
		if(obj_.getVertexRefCount(i) == 0) {
			continue;
		}
		if(is_selected && !doc_.isSelectVertex(obj_, i)) {
			continue;
		}
		if(symmetric.find(i) != symmetric.end()) {
			// Ɍς
			continue;
		}
		MQPoint pi = obj_.getVertex(i);
		if(abs(pi.x) < delta) {
			// ΏۋEʏ
			symmetric.insert(make_pair(i, i));
			doc_.deleteSelectVertex(obj_, i);
			continue;
		}
		pi.x = -pi.x;
		bool is_symmetric = false;
		for(int j = 0; j < vcount; j++) {
			if(obj_.getVertexRefCount(j) == 0) {
				continue;
			}
			if(i == j) {
				continue;
			}
			MQPoint pj = obj_.getVertex(j);
			if((pi - pj).norm() < delta * delta) {
				// Ώے_
				is_symmetric = true;
				symmetric.insert(make_pair(j, i));
				symmetric.insert(make_pair(i, j));
				doc_.deleteSelectVertex(obj_, i);
				doc_.deleteSelectVertex(obj_, j);
				break;
			}
		}
		if(!is_symmetric) {
			// Ώ̒_
			asymmetric.insert(i);
			doc_.addSelectVertex(obj_, i);
		}
	}
	return make_pair(symmetric, asymmetric);
}

// vertexes̊e_̑Ώ̒_
vector<int> SelectAsymmetric::getSymmetricVertexesofFace(const vector<int> &vertexes, const unordered_map<int, int> &vsymmetric)
{
	vector<int> symvertexes; // vertex1̊e_̑Ώۈʒu̒_
	symvertexes.reserve(vertexes.size()); 
	for(int v : vertexes) {
		auto it = vsymmetric.find(v);
		if(it != vsymmetric.end()) {
			symvertexes.push_back(it->second);
		}
		else {
			break;
		}
	}
	return symvertexes;
}

// _Qvertexesō\ʂ
int SelectAsymmetric::findFace(const vector<int> &vertexes)
{
	set<int> target; // e_ɋʂ̖ʂ邽߂̐ϏWi[
	for(int v2 : vertexes) {
		vector<int> faces = obj_.getVertexRelatedFaces(v2);
		set<int> s; // v2܂ޖʂsetBtargetƂ̐ϏW߂邽
		for(int findex : faces) {
			s.insert(findex);
		}
		if(target.empty()) {
			target = s;
		}
		else {
			set<int> tmp;
			set_intersection(target.begin(), target.end(), s.begin(), s.end(), inserter(tmp, tmp.begin()));
			if(tmp.empty()) {
				// ʂĂȂ
				target.clear();
				break;
			}
			target = tmp;
		}
	}
	if(target.empty()) {
		// Ώے_͈ʂʂĂȂ
		return -1;
	}
	return *target.begin();
}


// _tɓ
bool SelectAsymmetric::isReverseVector(const vector<int> &vector1, const vector<int> &vector2)
{
	if(vector1.front() == vector2.back()) {
		return equal(vector2.begin(), vector2.end(), vector1.rbegin());
	}
	else {
		auto it = find(vector1.begin(), vector1.end(), vector2.back());
		if(it == vector1.end()) {
			// _ĂȂ
			return false;
		}
		vector<int> vector3(vector1.size());
		rotate_copy(vector1.begin(), it, vector1.end(), vector3.begin());
		return equal(vector2.begin(), vector2.end(), vector3.rbegin());
	}
}

// _UVtɓ
bool SelectAsymmetric::isReverseVector2(const vector<CMQCoordinate> &vector1_, const vector<CMQCoordinate> &vector2, const unordered_map<int, int> &vsymmetric)
{
	vector<CMQCoordinate> vector1;
	for(CMQCoordinate co : vector1_) {
		auto it = vsymmetric.find(co.getIndex());
		if(it == vsymmetric.end()) {
			return false;
		}
		vector1.push_back(CMQCoordinate(it->second, co.getCoordinate()));
	}
	if(vector1.front() == vector2.back()) {
		return equal(vector2.begin(), vector2.end(), vector1.rbegin(), CMQCoordinate::uvcomp);
	}
	else {
		auto it = find(vector1.begin(), vector1.end(), vector2.back());
		if(it == vector1.end()) {
			// _ĂȂ
			return false;
		}
		vector<CMQCoordinate> vector3(vector1.size());
		rotate_copy(vector1.begin(), it, vector1.end(), vector3.begin());
		bool b = equal(vector2.begin(), vector2.end(), vector3.rbegin(), CMQCoordinate::uvcomp);
		if(!b) {
			int s = vector3.size();
		}
		return b;
	}
}

pair<unordered_map<int, int>, unordered_set<int>> SelectAsymmetric::selectAsymmetricFace(const unordered_map<int, int> &vsymmetric)
{
	int fcount = obj_.getFaceCount();
	bool is_selected = false;
	for(int i = 0; i < fcount; i++) {
		if(obj_.getFacePointCount(i) == 0) {
			continue;
		}
		is_selected |= doc_.isSelectFace(obj_, i);
	}

	unordered_map<int, int> fsymmetric; // Ώ̖ʂyAi[
	unordered_set<int> fasymmetric; // Ώ̖ʂ݂Ȃ̂i[
	for(int findex = 0; findex < fcount; findex++) {
		if(obj_.getFacePointCount(findex) == 0) {
			continue;
		}
		if(is_selected && !doc_.isSelectFace(obj_, findex)) {
			continue;
		}
		if(!obj_.getFaceVisible(findex)) {
			// \
			continue;
		}
		if(fsymmetric.find(findex) != fsymmetric.end() ||
			fasymmetric.find(findex) != fasymmetric.end()) {
			// Ɍς
			continue;
		}
		bool is_symmetric = false;
		// findex̑Ώۖʂ = findexɊ܂܂e_̑Ώ̒_ō\ʂ
		auto vertexes = obj_.getFacePointArray(findex);
		auto symvertexes = getSymmetricVertexesofFace(vertexes, vsymmetric);
		if(vertexes.size() != symvertexes.size()) {
			// ȂΏے_
			fasymmetric.insert(findex);
			if(!is_selected) {doc_.addSelectFace(obj_, findex);}
			continue;
		}
		// _Qvertexesō\ʂ
		int fsymindex = findFace(symvertexes);
		if(fsymindex == -1) {
			fasymmetric.insert(findex);
			if(!is_selected) {doc_.addSelectFace(obj_, findex);}
			continue;
		}
		if(fsymindex == findex) {
			// g񂾑Ώ̂Ȗʂłꍇ
			doc_.deleteSelectFace(obj_, findex);
			fsymmetric.insert(make_pair(findex, findex));
			continue;
		}
		// ʂ̌mF
		vector<int> other_vertexes = obj_.getFacePointArray(fsymindex);
		if(!isReverseVector(other_vertexes, symvertexes)) {
			// _tƍvȂ = ʂ̕\t
			fasymmetric.insert(findex);
			fasymmetric.insert(fsymindex); // 
			if(!is_selected) {
				doc_.addSelectFace(obj_, findex);
				doc_.addSelectFace(obj_, fsymindex);
			}
			continue;
		}
		if(mode_ == 2) {
			// UVlr
			vector<CMQCoordinate> coordinates = obj_.getFaceCoordinateArray(findex);
			vector<CMQCoordinate> symcoordinates = obj_.getFaceCoordinateArray(fsymindex);
			if(!isReverseVector2(coordinates, symcoordinates, vsymmetric)) {
				fasymmetric.insert(findex);
				fasymmetric.insert(fsymindex); // 
				if(!is_selected) {
					doc_.addSelectFace(obj_, findex);
					doc_.addSelectFace(obj_, fsymindex);
				}
				continue;
			}
		}
		// Ώ
		doc_.deleteSelectFace(obj_, findex);
		doc_.deleteSelectFace(obj_, fsymindex);
		fsymmetric.insert(make_pair(findex, fsymindex));
	}
	return make_pair(fsymmetric, fasymmetric);
}
